Package: leafdown
Type: Package
Title: Provides Drill Down Functionality for 'leaflet' Choropleths
Version: 1.2.0
Authors@R: c(
    person("Andreas", "Hofheinz", email = "andreas.hofheinz@outlook.com", role = "cre"),
    person("Peter", "Gandenberger", email = "peter.gandenberger@gmail.com", role = "aut"))
Description: Provides drill down functionality for 'leaflet' choropleths in 'shiny' apps.
License: GPL-3
Encoding: UTF-8
LazyData: true
Suggests: covr, testthat, knitr, rmarkdown, shinytest, dplyr,
        htmltools, raster, rmapshaper, shinycssloaders
RoxygenNote: 7.1.2
Depends: R (>= 3.5.0)
Imports: R6, leaflet, magrittr, checkmate, shiny, shinyjs
VignetteBuilder: knitr, shinycssloaders
NeedsCompilation: no
Packaged: 2022-09-12 19:28:03 UTC; andre
Author: Andreas Hofheinz [cre],
  Peter Gandenberger [aut]
Maintainer: Andreas Hofheinz <andreas.hofheinz@outlook.com>
Repository: CRAN
Date/Publication: 2022-09-19 06:06:11 UTC
Built: R 4.6.0; ; 2026-04-29 04:22:59 UTC; unix

Package: leafdown
Type: Package
Title: Provides Drill Down Functionality for 'leaflet' Choropleths
Version: 1.2.0
Authors@R: c(
    person("Andreas", "Hofheinz", email = "andreas.hofheinz@outlook.com", role = "cre"),
    person("Peter", "Gandenberger", email = "peter.gandenberger@gmail.com", role = "aut"))
Description: Provides drill down functionality for 'leaflet' choropleths in 'shiny' apps.
License: GPL-3
Encoding: UTF-8
LazyData: true
Suggests: covr, testthat, knitr, rmarkdown, shinytest, dplyr,
        htmltools, raster, rmapshaper, shinycssloaders
RoxygenNote: 7.1.2
Depends: R (>= 3.5.0)
Imports: R6, leaflet, magrittr, checkmate, shiny, shinyjs
VignetteBuilder: knitr, shinycssloaders
NeedsCompilation: no
Packaged: 2022-09-12 19:28:03 UTC; andre
Author: Andreas Hofheinz [cre],
  Peter Gandenberger [aut]
Maintainer: Andreas Hofheinz <andreas.hofheinz@outlook.com>
Repository: CRAN
Date/Publication: 2022-09-19 06:06:11 UTC
Built: R 4.6.0; ; 2026-04-26 19:23:26 UTC; unix

<!-- README.md is generated from README.Rmd. Please edit that file -->

# leafdown <a><img id="leafdown-hex" src='man/figures/hex-leafdown.png' align="right" height="139px" /></a>

<!-- badges: start -->

[![Lifecycle:
stable](https://img.shields.io/badge/lifecycle-stable-brightgreen.svg)](https://lifecycle.r-lib.org/articles/stages.html#stable)
[![R-CMD-check](https://github.com/hoga-it/leafdown/workflows/R-CMD-check/badge.svg)](https://github.com/hoga-it/leafdown/actions)
<!-- badges: end -->

The leafdown package provides drilldown functionality for leaflet
choropleths in R Shiny apps.

<img src='man/figures/select_drilldown.PNG'/>

## Installation

You can install the released version of leafdown from
[CRAN](https://CRAN.R-project.org) with:

``` r
install.packages("leafdown")
```

You can install the development version from
[GitHub](https://github.com/) with:

``` r
# install.packages("devtools")
devtools::install_github("hoga-it/leafdown")
```

## Documentation

You can find the documentation
[here](https://hoga-it.github.io/leafdown/index.html).

## Features

-   Adds drilldown functionality for [leaflet
    choropleths](https://rstudio.github.io/leaflet/choropleths.html)
    maps.
-   Allows the selection of regions/shapes.
-   Easy to use and well-integrated into syntax of the
    [leaflet](https://rstudio.github.io/leaflet/) R package.
-   Allows communication of the map with other shiny elements
    (e.g. graphs).
-   Computationally efficient as drilldown is only executed for selected
    regions of interest.

## Showcase - Election Map

To showcase the features of the `leafdown` package we have created a
demo app. <br>

This app shows the 2016 us presidential election results as well as some
demographic information.<br> Click here for the [full demo
app](https://pega.shinyapps.io/election16/) and here for the
[documentation](https://hoga-it.github.io/leafdown/articles/Connection_to_other_elements.html).
<br> <br>

<img src='man/figures/app_election_map.png'/>

## Showcase - healthdown

The healthdown app allows interactive comparison of various health
factors at the U.S. state and county level. It was honored as “Runners
up” in the Shiny Contest 2021.

Link to healthdown: <https://hoga.shinyapps.io/healthdown/>

Code: <https://github.com/hoga-it/healthdown>

<img src='man/figures/healthdown_app.jpg'/>

## Showcase - Weather stations

This app allows interactive comparison of weather station measurements
between states, counties and individual stations. It was primarily
developed for Andreas’
[talk](https://www.rstudio.com/conference/2022/talks/leafdown-interactive-multi-layer-maps/)
at the rstudio::conf(2022), where he demonstrated the capabilities of
the leafdown package.

Link to the app: <https://hoga.shinyapps.io/leafdown_rstudio_conf_2022/>

Code: <https://github.com/andreash0/leafdown_rstudio_conf_2022>

<img src='man/figures/app_weather.png'/>

library(bs4Dash)
library(shiny)
library(shinyjs)
library(leaflet)
library(leafdown)
library(echarts4r)
library(dplyr)
library(tidyr)
library(RColorBrewer)

ui = bs4DashPage(
  title = "Leafdown Showcase - USA Election Data",
  header = bs4DashNavbar(tags$h3("Leafdown Showcase - USA Election Data", style = "margin-bottom: .2rem;")),
  sidebar = bs4DashSidebar(disable = TRUE),
  body = bs4DashBody(
    # set the background of the map-container to be white
    tags$head(
      tags$style(HTML(".leaflet-container { background: #fff; height: 100%}")),
      # workaround for the NA in leaflet legend see https://github.com/rstudio/leaflet/issues/615
      tags$style(HTML(".leaflet-control div:last-child {clear: both;}")),
      tags$style(HTML(".card {height: 100%;}")),
      tags$style(HTML(".col-sm-12:last-child .card {margin-bottom: 0 !important;}")),
      tags$style(HTML("#leafdown {height: 80% !important; margin-top: 10px; margin-bottom: 10px;}"))
    ),
    # we need shinyjs for the leafdown map
    useShinyjs(),
    fluidRow(
        # a card for the map
        bs4Card(
          title = "Map",
          closable = F,
          collapsible = F,
          width = 6,
          # a dropdown to select what KPI should be displayed on the map
          selectInput("map_sel", "Select what KPI to display on the map:",
                      c("Votes" = "votes","Unemployment" = "unemployment")),
          # the two buttons used for drilling
          actionButton("drill_down", "Drill Down"),
          actionButton("drill_up", "Drill Up"),
          # the actual map element
          leafletOutput("leafdown")
      ),

      # a column with the two graphs
      column(
        width = 6,
        # box for racial makeup graph
        bs4Card(
          width = 12,
          closable = F,
          collapsible = F,
          title = "Racial makeup in percentages",
          echarts4rOutput("socio")
        ),
        # box for party percent graph
        bs4Card(
          width = 12,
          closable = F,
          collapsible = F,
          title = "Votes in percent",
          echarts4rOutput("party")
        )
      )
    )
  )
)

library(raster)
library(rmapshaper)

usa0 <- raster::getData(country = "USA", level = 0)
usa0 <- rmapshaper::ms_simplify(usa0)
saveRDS(usa0, "inst/extdata/usa0.RDS")

usa1 <- raster::getData(country = "USA", level = 1)
usa1 <- rmapshaper::ms_simplify(usa1, keep = 0.5)
saveRDS(usa1, "inst/extdata/usa1.RDS")

usa2 <- raster::getData(country = "USA", level = 2)
usa2 <- rmapshaper::ms_simplify(usa2, keep = 0.5)
saveRDS(usa2, "inst/extdata/usa2.RDS")

library(raster)
library(rmapshaper)

# Germany
ger0 <- raster::getData(country = "Germany", level = 0)
ger0 <- rmapshaper::ms_simplify(ger0)
saveRDS(ger0, "inst/extdata/ger0-005.RDS")

ger1 <- raster::getData(country = "Germany", level = 1)
ger1 <- rmapshaper::ms_simplify(ger1, keep = 0.05)
saveRDS(ger1, "inst/extdata/ger1-005.RDS")

ger2 <- raster::getData(country = "Germany", level = 2)
ger2 <- rmapshaper::ms_simplify(ger2, keep = 0.05)
saveRDS(ger2, "inst/extdata/ger2-005.RDS")

# Austria
a0 <- raster::getData(country = "Austria", level = 0)
a0 <- rmapshaper::ms_simplify(a0)
saveRDS(a0, "inst/extdata/a0-005.RDS")

a1 <- raster::getData(country = "Austria", level = 1)
a1 <- rmapshaper::ms_simplify(a1, keep = 0.05)
saveRDS(a1, "inst/extdata/a1-005.RDS")

a2 <- raster::getData(country = "Austria", level = 2)
a2 <- rmapshaper::ms_simplify(a2, keep = 0.05)
saveRDS(a2, "inst/extdata/a2-005.RDS")

# Switzerland
ch0 <- raster::getData(country = "Switzerland", level = 0)
ch0 <- rmapshaper::ms_simplify(ch0)
saveRDS(ch0, "inst/extdata/ch0-005.RDS")

ch1 <- raster::getData(country = "Switzerland", level = 1)
ch1 <- rmapshaper::ms_simplify(ch1, keep = 0.05)
saveRDS(ch1, "inst/extdata/ch1-005.RDS")

ch2 <- raster::getData(country = "Switzerland", level = 2)
ch2 <- rmapshaper::ms_simplify(ch2, keep = 0.05)
saveRDS(ch2, "inst/extdata/ch2-005.RDS")

## ---- include = FALSE---------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ---- echo=FALSE, out.width="70%"---------------------------------------------
knitr::include_graphics("../man/figures/app_dach_map.png")

## ----setup, message=FALSE,warning=FALSE---------------------------------------
library(leafdown)
library(leaflet)
library(shiny)
library(dplyr)
library(shinycssloaders)
library(shinyjs)
library(dplyr)
library(raster)

## ---- echo=FALSE--------------------------------------------------------------
ger0 <- readRDS("../inst/extdata/ger0-005.RDS")
ger1 <- readRDS("../inst/extdata/ger1-005.RDS")
ger2 <- readRDS("../inst/extdata/ger2-005.RDS")
aut0 <- readRDS("../inst/extdata/a0-005.RDS")
aut1 <- readRDS("../inst/extdata/a1-005.RDS")
aut2 <- readRDS("../inst/extdata/a2-005.RDS")
ch0 <- readRDS("../inst/extdata/ch0-005.RDS")
ch1 <- readRDS("../inst/extdata/ch1-005.RDS")
ch2 <- readRDS("../inst/extdata/ch2-005.RDS")

## ---- eval=FALSE--------------------------------------------------------------
#  # Germany
#  ger0 <- raster::getData(country = "Germany", level = 0)
#  ger1 <- raster::getData(country = "Germany", level = 1)
#  ger2 <- raster::getData(country = "Germany", level = 2)
#  # Austria
#  a0 <- raster::getData(country = "Austria", level = 0)
#  a1 <- raster::getData(country = "Austria", level = 1)
#  a2 <- raster::getData(country = "Austria", level = 2)
#  # Switzerland
#  ch0 <- raster::getData(country = "Switzerland", level = 0)
#  ch1 <- raster::getData(country = "Switzerland", level = 1)
#  ch2 <- raster::getData(country = "Switzerland", level = 2)

## ---- message=FALSE-----------------------------------------------------------
spdfs_list <- list(rbind(aut0, ch0, ger0), rbind(aut1, ch1, ger1), rbind(aut2, ch2, ger2))

## ---- message=FALSE-----------------------------------------------------------
set.seed(20220106)
# Simulate data
data_sim_y_level_3 <- spdfs_list[[3]]@data
data_sim_y_level_3$y <- round(rnorm(nrow(data_sim_y_level_3), 1e2, sd = 5e2), 0)
data_sim_y_level_2 <- data_sim_y_level_3 %>% group_by(NAME_0, NAME_1) %>% summarise(y = sum(y))
data_sim_y_level_1 <- data_sim_y_level_2 %>% group_by(NAME_0) %>% summarise(y = sum(y))

# Assign map levels
data_sim_y_level_3$level <- 3
data_sim_y_level_2$level <- 2
data_sim_y_level_1$level <- 1

# Assign area names
data_sim_y_level_3$area <- data_sim_y_level_3$NAME_2
data_sim_y_level_2$area <- data_sim_y_level_2$NAME_1
data_sim_y_level_1$area <- data_sim_y_level_1$NAME_0

# Combine data of map levels
data_sim_y <- rbind(
  data_sim_y_level_3[, c("area", "y", "level")],
  data_sim_y_level_2[, c("area", "y", "level")],
  data_sim_y_level_1[, c("area", "y", "level")]
)

head(data_sim_y)

## -----------------------------------------------------------------------------
head(spdfs_list[[1]]@data)

## -----------------------------------------------------------------------------
head(spdfs_list[[2]]@data[, c("GID_0", "NAME_0", "GID_1", "NAME_1")])

## -----------------------------------------------------------------------------
head(spdfs_list[[3]]@data[, c("GID_0", "NAME_0", "GID_1", "NAME_1", "GID_2", "NAME_2")])

## ---- eval=FALSE--------------------------------------------------------------
#  my_leafdown <- Leafdown$new(
#    spdfs_list, "leafdown", input, join_map_levels_by = c("GID_0" = "GID_0", "GID_1" = "GID_1")
#  )

## ---- eval=FALSE--------------------------------------------------------------
#  library(leafdown)
#  library(leaflet)
#  library(shiny)
#  library(dplyr)
#  library(shinycssloaders)
#  library(shinyjs)
#  library(dplyr)
#  library(raster)
#  
#  # Germany
#  ger0 <- raster::getData(country = "Germany", level = 0)
#  ger1 <- raster::getData(country = "Germany", level = 1)
#  ger2 <- raster::getData(country = "Germany", level = 2)
#  # Austria
#  a0 <- raster::getData(country = "Austria", level = 0)
#  a1 <- raster::getData(country = "Austria", level = 1)
#  a2 <- raster::getData(country = "Austria", level = 2)
#  # Switzerland
#  ch0 <- raster::getData(country = "Switzerland", level = 0)
#  ch1 <- raster::getData(country = "Switzerland", level = 1)
#  ch2 <- raster::getData(country = "Switzerland", level = 2)
#  
#  # load the shapes for the three levels
#  spdfs_list <- list(rbind(aut0, ch0, ger0), rbind(aut1, ch1, ger1), rbind(aut2, ch2, ger2))
#  
#  # Simulate some data
#  set.seed(20220106)
#  data_sim_y_level_3 <- spdfs_list[[3]]@data
#  data_sim_y_level_3$y <- rnorm(nrow(data_sim_y_level_3), 1e2, sd = 5e2)
#  data_sim_y_level_2 <- data_sim_y_level_3 %>% group_by(NAME_0, NAME_1) %>% summarise(y = sum(y))
#  data_sim_y_level_1 <- data_sim_y_level_2 %>% group_by(NAME_0) %>% summarise(y = sum(y))
#  
#  data_sim_y_level_3$level <- 3
#  data_sim_y_level_2$level <- 2
#  data_sim_y_level_1$level <- 1
#  
#  data_sim_y_level_3$area <- data_sim_y_level_3$NAME_2
#  data_sim_y_level_2$area <- data_sim_y_level_2$NAME_1
#  data_sim_y_level_1$area <- data_sim_y_level_1$NAME_0
#  
#  data_sim_y <- rbind(
#    data_sim_y_level_3[, c("area", "y", "level")],
#    data_sim_y_level_2[, c("area", "y", "level")],
#    data_sim_y_level_1[, c("area", "y", "level")]
#  )
#  data_sim_y$y <- round(data_sim_y$y, 0)

## ---- eval=FALSE--------------------------------------------------------------
#  ui <- fluidPage(
#    mainPanel(
#      # set the background of the map-container to be white
#      tags$head(
#        tags$style(HTML(".leaflet-container { background: #fff; height: 100%}")),
#        # workaround for the NA in leaflet legend see https://github.com/rstudio/leaflet/issues/615
#        tags$style(HTML(".leaflet-control div:last-child {clear: both;}"))
#      ),
#      # we need shinyjs for the leafdown map
#      useShinyjs(),
#      fluidRow(
#        # the two buttons used for drilling
#        actionButton("drill_down", "Drill Down"),
#        actionButton("drill_up", "Drill Up"),
#        # the actual map element
#        withSpinner(leafletOutput("leafdown", height = 800), type = 8)
#      )
#    )
#  )
#  

## -----------------------------------------------------------------------------
# Little helper function for hover labels
create_labels <- function(data, map_level) {
  labels <- sprintf(
    "<strong>%s</strong><br/>%g</sup>",
    data[, paste0("NAME_", map_level - 1)], data$y
  )
  labels %>% lapply(htmltools::HTML)
}

## ---- eval=FALSE--------------------------------------------------------------
#  server <- function(input, output) {
#  
#    # create leafdown object
#    my_leafdown <- Leafdown$new(
#      spdfs_list, "leafdown", input, join_map_levels_by = c("GID_0" = "GID_0", "GID_1" = "GID_1")
#    )
#  
#    rv <- reactiveValues()
#    rv$update_leafdown <- 0
#  
#    # observers for the drilling buttons
#    observeEvent(input$drill_down, {
#      my_leafdown$drill_down()
#      rv$update_leafdown <- rv$update_leafdown + 1
#    })
#  
#    observeEvent(input$drill_up, {
#      my_leafdown$drill_up()
#      rv$update_leafdown <- rv$update_leafdown + 1
#    })
#  
#    data <- reactive({
#      req(rv$update_leafdown)
#      meta_data <- my_leafdown$curr_data
#      curr_map_level <- my_leafdown$curr_map_level
#      data_curr_map_level <- data_sim_y[data_sim_y$level == curr_map_level, ]
#      join_col_lhs <- paste0("NAME_", curr_map_level - 1)
#      data <- meta_data %>% left_join(data_curr_map_level, by = setNames("area", join_col_lhs))
#  
#      # add the data back to the leafdown object
#      my_leafdown$add_data(data)
#      data
#    })
#  
#    # this is where the leafdown magic happens
#    output$leafdown <- renderLeaflet({
#      req(spdfs_list)
#      req(data)
#  
#      data <- data()
#      labels <- create_labels(data, my_leafdown$curr_map_level)
#      # draw the leafdown object
#      my_leafdown$draw_leafdown(
#        fillColor = ~leaflet::colorNumeric("Greens", data$y)(data$y),
#        weight = 3, fillOpacity = 1, color = "grey", label = labels
#      )
#    })
#  }

## ---- eval=FALSE--------------------------------------------------------------
#  shinyApp(ui, server)

file.copy(list.files("inst/extdata/", full.names = TRUE), "inst/app_germany/")
rsconnect::deployApp(appDir = "inst/app_germany", appName = "leafdown-basic-example", lint = FALSE,
                     appPrimaryDoc = "app_germany.R", account = "andreasho95")
file.remove("inst/app_germany/ger0-005.RDS")
file.remove("inst/app_germany/ger1-005.RDS")
file.remove("inst/app_germany/ger2-005.RDS")
file.remove("inst/app_germany/a0-005.RDS")
file.remove("inst/app_germany/a1-005.RDS")
file.remove("inst/app_germany/a2-005.RDS")
file.remove("inst/app_germany/ch0-005.RDS")
file.remove("inst/app_germany/ch1-005.RDS")
file.remove("inst/app_germany/ch2-005.RDS")
file.remove("inst/app_germany/usa0.RDS")
file.remove("inst/app_germany/usa1.RDS")
file.remove("inst/app_germany/usa2.RDS")

## ---- include = FALSE---------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ---- echo=FALSE, out.width="100%"--------------------------------------------
knitr::include_graphics("../man/figures/app_election_map.png")

## ---- eval = FALSE------------------------------------------------------------
#  column(
#    width = 5,
#    # box for racial makeup graph
#    bs4Card(
#      width = 12,
#      closable = F,
#      collapsible = F,
#      title = "Racial makeup in percentages",
#      echarts4rOutput("socio")
#    ),
#    # box for party percent graph
#    bs4Card(
#      width = 12,
#      closable = F,
#      collapsible = F,
#      title = "Votes in percent",
#      echarts4rOutput("party")
#    )
#  )

## ---- eval = FALSE------------------------------------------------------------
#  output$party <- renderEcharts4r({
#    # get the currently selected data from the map
#    df <- my_leafdown$curr_sel_data()
#  
#    # check whether any shape is selected, show general election-result if nothing is selected
#    if (nrow(df) > 0) {
#      if (my_leafdown$curr_map_level == 1) {
#        df <- df[, c("state_abbr", "Democrats2016", "Republicans2016", "Libertarians2016", "Green2016")]
#        df <- df %>%
#          pivot_longer(2:5, "party") %>%
#          group_by(party)
#      } else {
#        df <- df[, c("County", "Democrats2016", "Republicans2016", "Libertarians2016", "Green2016")]
#        df <- df %>%
#          pivot_longer(2:5, "party") %>%
#          group_by(party)
#        df$value <- df$value
#        names(df)[1] <- "state_abbr"
#      }
#    } else {
#      # show general election-result as no state is selected
#      df <- data.frame(
#        party = c("Democrats2016", "Republicans2016", "Libertarians2016", "Green2016"),
#        state_abbr = "USA",
#        value = c(0.153, 0.634, 0.134, 0.059)
#      ) %>%
#        group_by(party)
#    }
#    # create the graph
#    df %>%
#      e_charts(state_abbr, stack = "grp") %>%
#      e_bar(value) %>%
#      e_y_axis(formatter = e_axis_formatter("percent", digits = 2)) %>%
#      e_tooltip(trigger = "axis", axisPointer = list(type = "shadow")) %>%
#      e_legend(right = 10, top = 10) %>%
#      e_color(c("#232066", "#E91D0E", "#f3b300", "#006900")) %>%
#      e_tooltip(formatter = e_tooltip_item_formatter("percent", digits = 2))
#  })

## ---- eval=FALSE--------------------------------------------------------------
#  states <- raster::getData(country = "USA", level = 1)
#  counties <- raster::getData(country = "USA", level = 2)
#  # TODO replace the path to your downloaded shapes in the server code

## ---- eval=FALSE--------------------------------------------------------------
#  library(shiny)
#  library(bs4Dash)
#  library(shinyjs)
#  library(leaflet)
#  library(leafdown)
#  library(echarts4r)
#  library(dplyr)
#  library(tidyr)
#  library(RColorBrewer)
#  
#  ui <- bs4DashPage(
#    title = "Leafdown Showcase - USA Election Data",
#    navbar = bs4DashNavbar(tags$h3("Leafdown Showcase - USA Election Data", style = "margin-bottom: .2rem;")),
#    bs4DashSidebar(disable = TRUE),
#    body = bs4DashBody(
#      # set the background of the map-container to be white
#      tags$head(
#        tags$style(HTML(".leaflet-container { background: #fff; height: 100%}")),
#        # workaround for the NA in leaflet legend see https://github.com/rstudio/leaflet/issues/615
#        tags$style(HTML(".leaflet-control div:last-child {clear: both;}")),
#        tags$style(HTML(".card {height: 100%;}")),
#        tags$style(HTML(".col-sm-12:last-child .card {margin-bottom: 0 !important;}")),
#        tags$style(HTML("#leafdown {height: 80% !important; margin-top: 10px; margin-bottom: 10px;}"))
#      ),
#      # we need shinyjs for the leafdown map
#      useShinyjs(),
#      fluidRow(
#        # a card for the map
#        bs4Card(
#          title = "Map",
#          closable = FALSE,
#          collapsible = FALSE,
#          width = 6,
#          # a dropdown to select what KPI should be displayed on the map
#          selectInput(
#            "map_sel", "Select what KPI to display on the map:",
#            c("Votes" = "votes", "Unemployment" = "unemployment")
#          ),
#          # the two buttons used for drilling
#          actionButton("drill_down", "Drill Down"),
#          actionButton("drill_up", "Drill Up"),
#          # the actual map element
#          leafletOutput("leafdown")
#        ),
#  
#        # a column with the two graphs
#        column(
#          width = 6,
#          # box for racial makeup graph
#          bs4Card(
#            width = 12,
#            closable = F,
#            collapsible = F,
#            title = "Racial makeup in percentages",
#            echarts4rOutput("socio")
#          ),
#          # box for party percent graph
#          bs4Card(
#            width = 12,
#            closable = F,
#            collapsible = F,
#            title = "Votes in percent",
#            echarts4rOutput("party")
#          )
#        )
#      )
#    )
#  )
#  
#  # Create user-defined function
#  percent <- function(x, digits = 2, format = "f", ...) {
#    paste0(formatC(x * 100, format = format, digits = digits, ...), "%")
#  }
#  
#  create_labels <- function(data, map_level) {
#    labels <- sprintf(
#      "<strong>%s</strong><br/>
#      Democrats: %s<br/>
#      Republicans: %s<br/>
#      Libertarians: %s<br/>
#      Green: %s<br/>
#      </sup>",
#      data[, paste0("NAME_", map_level)],
#      percent(data$Democrats2016),
#      percent(data$Republicans2016),
#      percent(data$Libertarians2016),
#      percent(data$Green2016)
#    )
#    labels %>% lapply(htmltools::HTML)
#  }
#  
#  # Define server for leafdown app
#  server <- function(input, output) {
#    # load the shapes for the two levels
#    # TODO load the shapes you have downloaded via the raster package
#    states <- readRDS("../inst/app_election/us1.RDS")
#    counties <- readRDS("../inst/app_election/us2.RDS")
#    spdfs_list <- list(states, counties)
#  
#    # create leafdown object
#    my_leafdown <- Leafdown$new(spdfs_list, "leafdown", input)
#  
#    rv <- reactiveValues()
#    rv$update_leafdown <- 0
#  
#    # observers for the drilling buttons
#    observeEvent(input$drill_down, {
#      my_leafdown$drill_down()
#      rv$update_leafdown <- rv$update_leafdown + 1
#    })
#  
#    observeEvent(input$drill_up, {
#      my_leafdown$drill_up()
#      rv$update_leafdown <- rv$update_leafdown + 1
#    })
#  
#    data <- reactive({
#      req(rv$update_leafdown)
#      # fetch the current metadata from the leafdown object
#      data <- my_leafdown$curr_data
#  
#      # join the metadata with the election-data.
#      # depending on the map_level we have different election-data so the 'by' columns for the join are different
#      if (my_leafdown$curr_map_level == 2) {
#        data$ST <- substr(data$HASC_2, 4, 5)
#        # there are counties with the same name in different states so we have to join on both
#        data <- left_join(data, us_election_counties, by = c("NAME_2", "ST"))
#      } else {
#        data$ST <- substr(data$HASC_1, 4, 5)
#        data <- left_join(data, us_election_states, by = "ST")
#      }
#      # add the data back to the leafdown object
#      my_leafdown$add_data(data)
#      data
#    })
#  
#    # this is where the leafdown magic happens
#    output$leafdown <- renderLeaflet({
#      req(spdfs_list)
#      req(data)
#  
#      data <- data()
#  
#      # depending on the selected KPI in the dropdown we show different data
#      if (input$map_sel == "unemployment") {
#        data$y <- data$Unemployment * 100
#        fillcolor <- leaflet::colorNumeric("Greens", data$y)
#        legend_title <- "Unemployment in Percent"
#      } else {
#        data$y <- ifelse(data$Republicans2016 > data$Democrats2016, "Republicans", "Democrats")
#        fillcolor <- leaflet::colorFactor(c("#232066", "#E91D0E"), data$y)
#        legend_title <- "Winning Party"
#      }
#  
#      labels <- create_labels(data, my_leafdown$curr_map_level)
#      # draw the leafdown object
#      my_leafdown$draw_leafdown(
#        fillColor = ~ fillcolor(data$y),
#        weight = 3, fillOpacity = 1, color = "white", label = labels
#      ) %>%
#        # set the view to be center on the USA
#        setView(-95, 39, 4) %>%
#        # add a nice legend
#        addLegend(
#          pal = fillcolor,
#          values = ~ data$y,
#          title = legend_title,
#          opacity = 1
#        )
#    })
#  
#    # plots
#    output$socio <- renderEcharts4r({
#      df <- my_leafdown$curr_sel_data()
#      # check whether any shape is selected, show basic info for the whole usa if nothing is selected
#      if (nrow(df) > 0) {
#        if (my_leafdown$curr_map_level == 1) {
#          df <- df[, c("State", "Hispanic", "White", "Black", "Asian", "Amerindian", "Other")]
#          df <- df %>%
#            pivot_longer(2:7, "race") %>%
#            group_by(State)
#          df$value <- round(df$value, 2)
#        } else {
#          df <- df[, c("County", "Hispanic", "White", "Black", "Asian", "Amerindian", "Other")]
#          df <- df %>%
#            pivot_longer(2:7, "race") %>%
#            group_by(County)
#          df$value <- round(df$value / 100, 2)
#        }
#      } else {
#        # show basic info for the whole usa as no state is selected
#        df <- data.frame(
#          ST = "USA",
#          race = c("Hispanic", "White", "Black", "Asian", "Amerindian", "Other"),
#          value = c(0.15, 0.634, 0.134, 0.059, 0.015, 0.027)
#        ) %>%
#          group_by(ST)
#      }
#      # create the graph
#      df %>%
#        e_charts(race) %>%
#        e_bar(value) %>%
#        e_tooltip(trigger = "axis", axisPointer = list(type = "shadow")) %>%
#        e_y_axis(
#          splitArea = list(show = FALSE),
#          splitLine = list(show = FALSE),
#          formatter = e_axis_formatter("percent", digits = 2)
#        ) %>%
#        e_legend(orient = "vertical", right = 10, top = 10) %>%
#        e_color(brewer.pal(nrow(df), "Set3")) %>%
#        e_tooltip(formatter = e_tooltip_item_formatter("percent"))
#    })
#  
#    output$party <- renderEcharts4r({
#      df <- my_leafdown$curr_sel_data()
#      # check whether any shape is selected, show general election-result if nothing is selected
#      if (nrow(df) > 0) {
#        if (my_leafdown$curr_map_level == 1) {
#          df <- df[, c("ST", "Democrats2016", "Republicans2016", "Libertarians2016", "Green2016")]
#          df <- df %>%
#            pivot_longer(2:5, "party") %>%
#            group_by(party)
#        } else {
#          df <- df[, c("County", "Democrats2016", "Republicans2016", "Libertarians2016", "Green2016")]
#          df <- df %>%
#            pivot_longer(2:5, "party") %>%
#            group_by(party)
#          df$value <- df$value
#          names(df)[1] <- "ST"
#        }
#      } else {
#        # show general election-result as no state is selected
#        df <- data.frame(
#          party = c("Democrats2016", "Republicans2016", "Libertarians2016", "Green2016"),
#          ST = "USA",
#          value = c(0.153, 0.634, 0.134, 0.059)
#        ) %>%
#          group_by(party)
#      }
#      # create the graph
#      df %>%
#        e_charts(ST, stack = "grp") %>%
#        e_bar(value) %>%
#        e_y_axis(formatter = e_axis_formatter("percent", digits = 2)) %>%
#        e_tooltip(trigger = "axis", axisPointer = list(type = "shadow")) %>%
#        e_legend(right = 10, top = 10) %>%
#        e_color(c("#232066", "#E91D0E", "#f3b300", "#006900")) %>%
#        e_tooltip(formatter = e_tooltip_item_formatter("percent", digits = 2))
#    })
#  }
#  
#  shinyApp(ui, server)
#  

library(leafdown)
# Run this before uploading
# devtools::install_github("https://github.com/hoga-it/leafdown/tree/multiple-map-levels")
library(leaflet)
library(shiny)
library(dplyr)
library(shinycssloaders)
library(shinyjs)
library(dplyr)

# Uncomment this when uploading
# ger0 <- readRDS("ger0-005.RDS")
# ger1 <- readRDS("ger1-005.RDS")
# ger2 <- readRDS("ger2-005.RDS")
# aut0 <- readRDS("a0-005.RDS")
# aut1 <- readRDS("a1-005.RDS")
# aut2 <- readRDS("a2-005.RDS")
# ch0 <- readRDS("ch0-005.RDS")
# ch1 <- readRDS("ch1-005.RDS")
# ch2 <- readRDS("ch2-005.RDS")


# Comment this when uploading
ger0 <- readRDS("../extdata/ger0-005.RDS")
ger1 <- readRDS("../extdata/ger1-005.RDS")
ger2 <- readRDS("../extdata/ger2-005.RDS")
aut0 <- readRDS("../extdata/a0-005.RDS")
aut1 <- readRDS("../extdata/a1-005.RDS")
aut2 <- readRDS("../extdata/a2-005.RDS")
ch0 <- readRDS("../extdata/ch0-005.RDS")
ch1 <- readRDS("../extdata/ch1-005.RDS")
ch2 <- readRDS("../extdata/ch2-005.RDS")

# load the shapes for the three levels
spdfs_list <- list(rbind(aut0, ch0, ger0), rbind(aut1, ch1, ger1), rbind(aut2, ch2, ger2))

set.seed(20220106)
data_sim_y_level_3 <- spdfs_list[[3]]@data
data_sim_y_level_3$y <- rnorm(nrow(data_sim_y_level_3), 1e2, sd = 5e2)
data_sim_y_level_2 <- data_sim_y_level_3 %>% group_by(NAME_0, NAME_1) %>% summarise(y = sum(y))
data_sim_y_level_1 <- data_sim_y_level_2 %>% group_by(NAME_0) %>% summarise(y = sum(y))

data_sim_y_level_3$level <- 3
data_sim_y_level_2$level <- 2
data_sim_y_level_1$level <- 1

data_sim_y_level_3$area <- data_sim_y_level_3$NAME_2
data_sim_y_level_2$area <- data_sim_y_level_2$NAME_1
data_sim_y_level_1$area <- data_sim_y_level_1$NAME_0

data_sim_y <- rbind(
  data_sim_y_level_3[, c("area", "y", "level")],
  data_sim_y_level_2[, c("area", "y", "level")],
  data_sim_y_level_1[, c("area", "y", "level")]
)
data_sim_y$y <- round(data_sim_y$y, 0)

create_labels <- function(data, map_level) {
  labels <- sprintf(
    "<strong>%s</strong><br/>%g</sup>",
    data[, paste0("NAME_", map_level - 1)], data$y
  )
  labels %>% lapply(htmltools::HTML)
}

ui <- fluidPage(
  mainPanel(
    # set the background of the map-container to be white
    tags$head(
      tags$style(HTML(".leaflet-container { background: #fff; height: 100%}")),
      # workaround for the NA in leaflet legend see https://github.com/rstudio/leaflet/issues/615
      tags$style(HTML(".leaflet-control div:last-child {clear: both;}"))
    ),
    # we need shinyjs for the leafdown map
    useShinyjs(),
    fluidRow(
      # the two buttons used for drilling
      actionButton("drill_down", "Drill Down"),
      actionButton("drill_up", "Drill Up"),
      # the actual map element
      withSpinner(leafletOutput("leafdown", height = 800), type = 8)
    )
  )
)



# Define server for leafdown app
server <- function(input, output) {


  # create leafdown object
  my_leafdown <- Leafdown$new(spdfs_list, "leafdown", input, join_map_levels_by = c("GID_0" = "GID_0", "GID_1" = "GID_1"))

  rv <- reactiveValues()
  rv$update_leafdown <- 0

  # observers for the drilling buttons
  observeEvent(input$drill_down, {
    my_leafdown$drill_down()
    rv$update_leafdown <- rv$update_leafdown + 1


  })

  observeEvent(input$drill_up, {
    my_leafdown$drill_up()
    rv$update_leafdown <- rv$update_leafdown + 1
  })

  data <- reactive({
    req(rv$update_leafdown)
    meta_data <- my_leafdown$curr_data
    curr_map_level <- my_leafdown$curr_map_level
    data_curr_map_level <- data_sim_y[data_sim_y$level == curr_map_level, ]
    join_col_lhs <- paste0("NAME_", curr_map_level - 1)
    data <- meta_data %>% left_join(data_curr_map_level, by = setNames("area", join_col_lhs))

    # add the data back to the leafdown object
    my_leafdown$add_data(data)
    data
  })

  # this is where the leafdown magic happens
  output$leafdown <- renderLeaflet({
    req(spdfs_list)
    req(data)

    data <- data()
    labels <- create_labels(data, my_leafdown$curr_map_level)
    # draw the leafdown object
    map <- my_leafdown$draw_leafdown(
      fillColor = ~leaflet::colorNumeric("Greens", data$y)(data$y),
      weight = 3, fillOpacity = 1, color = "grey", label = labels
    ) %>% my_leafdown$keep_zoom(input)

    map
  })
}

shinyApp(ui, server)

library(leafdown)
# Run before uploading
#devtools::install_github("hoga-it/leafdown")

# Comment this when uploading
states <- readRDS("../extdata/usa1.RDS")
counties <- readRDS("../extdata/usa2.RDS")

percent <- function(x, digits = 2, format = "f", ...) {      # Create user-defined function
  paste0(formatC(x * 100, format = format, digits = digits, ...), "%")
}

create_labels <- function(data, map_level) {
  labels <- sprintf(
    "<strong>%s</strong><br/>
    Democrats: %s<br/>
    Republicans: %s<br/>
    Libertarians: %s<br/>
    Green: %s<br/>
    </sup>",
    data[, paste0("NAME_", map_level)],
    percent(data$Democrats2016),
    percent(data$Republicans2016),
    percent(data$Libertarians2016),
    percent(data$Green2016)
  )
  labels %>% lapply(htmltools::HTML)
}

# Define server for leafdown app
server <- function(input, output) {
  # load the shapes for the two levels
  spdfs_list <- list(states, counties)

  # create leafdown object
  my_leafdown <- Leafdown$new(spdfs_list, "leafdown", input)

  rv <- reactiveValues()
  rv$update_leafdown <- 0

  # observers for the drilling buttons
  observeEvent(input$drill_down, {
    my_leafdown$drill_down()
    rv$update_leafdown <- rv$update_leafdown + 1
  })

  observeEvent(input$drill_up, {
    my_leafdown$drill_up()
    rv$update_leafdown <- rv$update_leafdown + 1
  })

  data <- reactive({
    req(rv$update_leafdown)
    # fetch the current metadata from the leafdown object
    data <- my_leafdown$curr_data

    # join the metadata with the election-data.
    # depending on the map_level we have different election-data so the 'by' columns for the join are different
    if(my_leafdown$curr_map_level == 2) {
      data$ST <- substr(data$HASC_2, 4, 5)
      # there are counties with the same name in different states so we have to join on both
      data <- left_join(data, us_election_counties, by = c("NAME_2", "ST"))
    } else {
      data$ST <- substr(data$HASC_1, 4, 5)
      data <- left_join(data, us_election_states, by = "ST")
    }
    # add the data back to the leafdown object
    my_leafdown$add_data(data)
    data
  })

  # this is where the leafdown magic happens
  output$leafdown <- renderLeaflet({
    req(spdfs_list)
    req(data)

    data <- data()

    # depending on the selected KPI in the dropdown we show different data
    if(input$map_sel == "unemployment") {
      data$y <- data$Unemployment * 100
      fillcolor <- leaflet::colorNumeric("Greens", data$y)
      legend_title <- "Unemployment in Percent"
    } else {
      data$y <- ifelse(data$Republicans2016 > data$Democrats2016, "Republicans", "Democrats")
      fillcolor <- leaflet::colorFactor(c("#232066", "#E91D0E"), data$y)
      legend_title <- "Winning Party"
    }

    labels <- create_labels(data, my_leafdown$curr_map_level)
    # draw the leafdown object
    my_leafdown$draw_leafdown(
      fillColor = ~fillcolor(data$y),
      weight = 3, fillOpacity = 1, color = "white", label = labels) %>%
      # set the view to be center on the USA
      setView(-95, 39,  4)  %>%
      # add a nice legend
      addLegend(pal = fillcolor,
                values = ~data$y,
                title = legend_title,
                opacity = 1)
  })

  # plots
  output$socio <- renderEcharts4r({
    df <- my_leafdown$curr_sel_data()
    # check whether any shape is selected, show basic info for the whole usa if nothing is selected
    if(dim(df)[1] > 0){
      if(my_leafdown$curr_map_level == 1) {
        df <- df[, c("State", "Hispanic", "White", "Black", "Asian", "Amerindian", "Other")]
        df <- df %>% pivot_longer(2:7, "race") %>% group_by(State)
        df$value <- round(df$value, 2)
      } else {
        df <- df[, c("County", "Hispanic", "White", "Black", "Asian", "Amerindian", "Other")]
        df <- df %>% pivot_longer(2:7, "race") %>% group_by(County)
        df$value <- round(df$value/100, 2)
      }
    } else {
      # show basic info for the whole usa as no state is selected
      df <- data.frame(
        ST = "USA",
        race = c("Hispanic", "White", "Black", "Asian", "Amerindian", "Other"),
        value = c(0.15, 0.634, 0.134, 0.059, 0.015, 0.027)) %>% group_by(ST)
    }
    # create the graph
    df %>%
      e_charts(race) %>%
      e_bar(value) %>%
      e_tooltip(trigger = "axis",axisPointer = list(type = "shadow")) %>%
      e_y_axis(splitArea = list(show = FALSE),
               splitLine = list(show = FALSE),
               formatter = e_axis_formatter("percent", digits = 2)) %>%
      e_legend(orient = 'vertical',right = 10,top = 10) %>%
      e_color(brewer.pal(nrow(df), "Set3")) %>%
      e_tooltip(formatter = e_tooltip_item_formatter("percent"))
  })

  output$party <- renderEcharts4r({
    df <- my_leafdown$curr_sel_data()
    # check whether any shape is selected, show general election-result if nothing is selected
    if(dim(df)[1] > 0){
      if(my_leafdown$curr_map_level == 1) {
        df <- df[, c("ST", "Democrats2016", "Republicans2016", "Libertarians2016", "Green2016")]
        df <- df %>% pivot_longer(2:5, "party") %>% group_by(party)
      } else {
        df <- df[, c("County", "Democrats2016", "Republicans2016", "Libertarians2016", "Green2016")]
        df <- df %>% pivot_longer(2:5, "party") %>% group_by(party)
        df$value <- df$value
        names(df)[1] <- "ST"
      }
    } else {
      # show general election-result as no state is selected
      df <- data.frame(
        party = c("Democrats2016", "Republicans2016", "Libertarians2016", "Green2016"),
        ST = "USA",
        value = c(0.153, 0.634, 0.134, 0.059)) %>% group_by(party)
    }
    # create the graph
    df %>%
      e_charts(ST, stack="grp") %>%
      e_bar(value) %>%
      e_y_axis(formatter = e_axis_formatter("percent", digits = 2)) %>%
      e_tooltip(trigger = "axis",axisPointer = list(type = "shadow")) %>%
      e_legend(right = 10,top = 10) %>%
      e_color(c("#232066", "#E91D0E", "#f3b300", "#006900"))%>%
      e_tooltip(formatter = e_tooltip_item_formatter("percent", digits = 2))
  })
}

library(leafdown)
# Run this before uploading
# devtools::install_github("https://github.com/hoga-it/leafdown")
library(leaflet)
library(shiny)
library(dplyr)
library(shinycssloaders)
library(shinyjs)

# Uncomment this when uploading
# ger1 <- readRDS("ger1-005.RDS")
# ger2 <- readRDS("ger2-005.RDS")

# Comment this when uploading
ger1 <- readRDS("../extdata/ger1-005.RDS")
ger2 <- readRDS("../extdata/ger2-005.RDS")

ger2@data[c(76, 99, 136, 226), "NAME_2"] <- c(
  "Fürth (Kreisfreie Stadt)",
  "München (Kreisfreie Stadt)",
  "Osnabrück (Kreisfreie Stadt)",
  "Würzburg (Kreisfreie Stadt)"
)

spdfs_list <- list(ger1, ger2)

create_labels <- function(data, map_level) {
  labels <- sprintf(
    "<strong>%s</strong><br/>%g € per capita</sup>",
    data[, paste0("NAME_", map_level)], data$GDP_2014
  )
  labels %>% lapply(htmltools::HTML)
}

ui <- shiny::fluidPage(
  tags$style(HTML(".leaflet-container {background: #ffffff;}")),
  # Main
  useShinyjs(),
  actionButton("drill_down", "Drill Down"),
  actionButton("drill_up", "Drill Up"),
  withSpinner(leafletOutput("leafdown", height = 600), type = 8)
)

server <- function(input, output) {
  my_leafdown <- Leafdown$new(spdfs_list, "leafdown", input)
  update_leafdown <- reactiveVal(0)

  observeEvent(input$drill_down, {
    my_leafdown$drill_down()
    update_leafdown(update_leafdown() + 1)
  })

  observeEvent(input$drill_up, {
    my_leafdown$drill_up()
    update_leafdown(update_leafdown() + 1)
  })

  output$leafdown <- renderLeaflet({
    update_leafdown()
    meta_data <- my_leafdown$curr_data
    curr_map_level <- my_leafdown$curr_map_level
    if (curr_map_level == 1) {
      data <- meta_data %>% left_join(gdp_2014_federal_states, by = c("NAME_1" = "Federal_State"))
    } else {
      data <- meta_data %>% left_join(gdp_2014_admin_districts, by = c("NAME_2" = "Admin_District"))
    }

    my_leafdown$add_data(data)
    labels <- create_labels(data, curr_map_level)
    my_leafdown$draw_leafdown(
      fillColor = ~ colorNumeric("Greens", GDP_2014)(GDP_2014),
      weight = 2, fillOpacity = 0.8, color = "grey", label = labels,
      highlight = highlightOptions(weight = 5, color = "#666", fillOpacity = 0.7)
    ) %>% my_leafdown$keep_zoom(input) %>%
      addLegend(
        "topright",
        pal = colorNumeric("Greens", data$GDP_2014),
        values = data$GDP_2014,
        title = "GDP per capita (2014)",
        labFormat = labelFormat(suffix = "€"),
        opacity = 1
      )
  })
}

shinyApp(ui, server)

file.copy(list.files("inst/extdata/", full.names = TRUE), "inst/app_dach/")
rsconnect::deployApp(appDir = "inst/app_dach", appName = "leafdown-multi-level", lint = FALSE,
                     appPrimaryDoc = "app_dach.R", account = "andreasho95")
file.remove("inst/app_dach/ger0-005.RDS")
file.remove("inst/app_dach/ger1-005.RDS")
file.remove("inst/app_dach/ger2-005.RDS")
file.remove("inst/app_dach/a0-005.RDS")
file.remove("inst/app_dach/a1-005.RDS")
file.remove("inst/app_dach/a2-005.RDS")
file.remove("inst/app_dach/ch0-005.RDS")
file.remove("inst/app_dach/ch1-005.RDS")
file.remove("inst/app_dach/ch2-005.RDS")

---
title: "Introduction"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Introduction}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

In this article, we would like to give an example of how to create a very simple 
drilldown map with `leafdown`. \
The goal is to create a map that:

-  shows the GDP (gross domestic product) of the federal states of Germany 
-  allows the user to drill down to the administrative districts of selected federal states.


```{r, echo=FALSE, out.width=550, out.height=400}
knitr::include_graphics("../man/figures/app_germany_map.png")
```

Let's first load the libraries we are going to use for our app. \

```{r setup, message=FALSE,warning=FALSE}
library(leafdown)
library(leaflet)
library(shiny)
library(dplyr)
library(shinycssloaders)
library(shinyjs)
library(dplyr)
library(raster)
```

(Note that the `shinyjs` package is loaded for some automatic warning messages that the 
`leafdown` map can return to the user of the shiny app.)


## SpatialPolygonsDataFrames

`leafdown` requires a list of `SpatialPolygonsDataFrames` (`spdfs`) for the regions 
we want to display on our map.

To get these spdfs we can use the `getData` function of the `raster` package.
For "Germany", `level = 1` contains the spdf for the federal states
and `level = 2` the spdf for the administrative districts.

If an `spdf` comes from a different source, it is important that the structure 
is identical to the `spdfs` that come from the `raster` package.

```{r, echo=FALSE}
ger1 <- readRDS("../inst/extdata/ger1-005.RDS")
ger2 <- readRDS("../inst/extdata/ger2-005.RDS")
```

```{r, eval=FALSE}
ger1 <- raster::getData(country = "Germany", level = 1)
ger2 <- raster::getData(country = "Germany", level = 2)
```

The spdf for `level = 2` does not display all German umlauts correctly. Therefore 
we adjust  some names so that we can assign our data more easily later on.
```{r, message=FALSE}
ger2@data[c(76, 99, 136, 226), "NAME_2"] <- c(
  "Fürth (Kreisfreie Stadt)",
  "München (Kreisfreie Stadt)",
  "Osnabrück (Kreisfreie Stadt)",
  "Würzburg (Kreisfreie Stadt)"
)
```

Let's now create our `spdfs_list` which we can provide to `leafdown` in our shiny app.
It is important that `spdfs_list` is ordered such that the spdf of the highest map level 
(in our case the federal states) is the first list element and so on.

```
list (spdfs_list)
│   
└───spdf (spdf of first map level)
│
└───spdf (spdf of second map level)

```

```{r}
spdfs_list <- list(ger1, ger2)
```


## Data

For this app, we will use the example data sets that come with the `leafdown` package.
The data.frame `gdp_2014_federal_states`  contains the GPD of 2014 for the federal 
states and `gdp_2014_admin_districts` for the administrative districts of Germany.

```{r}
head(gdp_2014_federal_states)
```

```{r}
head(gdp_2014_admin_districts)
```

(For more information about the data, please see `?gdp_2014_federal_states` or
`?gdp_2014_admin_districts` respectively)



## Leafdown workflow
In this part, we sketch and explain the typical `leafdown` workflow. \

```{r, echo=FALSE, fig.width=7, eval=FALSE}
DiagrammeR::grViz('
digraph { 
  rankdir=LR; 
  rank="same";
  graph [fontname = "Segoe UI", fontsize = 36, 
         nodesep="2", ranksep="1", color = dimgrey];
  node [fontname = "Segoe UI", fontsize = 30, color = dimgrey];
  edge [fontname = "Segoe UI", fontsize = 30, color = dimgrey];
  "Invisible"[style=invis];
  c0 [
    label = "Initialization \n ($new)", fillcolor  = palegreen, 
    style=filled, color = "grey"
  ];
  
  subgraph cluster01 { 
    label="Map Level 1"; 
    rank="same";
    a0 [label="Add Data \n ($add_data)", fillcolor = OldLace, style=filled]; 
    a1 [label="Draw Map \n ($draw_leafdown)",  fillcolor = Moccasin, style=filled]; 
    a2 [label="Select Shapes", fillcolor = lightyellow, style=filled]; 
    a3 [label="Drill Down \n ($drill_down)", fillcolor = PowderBlue, style=filled]; 
    a0 -> a1;
    a1 -> a2; 
    a2 -> a3; 
  }; 
  
  subgraph cluster02 
  {
    label="Map Level 2";
    rank="same";
    b0 [label="    Drill Up   \n ($drill_up)", fillcolor = PowderBlue, style=filled]; 
    b3 [label="   Add Data   \n ($add_data) ", fillcolor = OldLace, style=filled]; 
    b1 [label="..."]; 
    b2 [label="Draw Map \n ($draw_leafdown)", fillcolor = Moccasin, style=filled]; 
    
    b0 -> b1 [dir="back"]; 
    b1 -> b2 [dir="back"]; 
    b2 -> b3 [dir="back"]; 

  }; 
  
  edge[constraint=false]; 
  a1->b1 [style=invis]; 
  a2->b2 [style=invis]; 
  a3->b3 [style=dotted];
  b0->a0 [style=dotted];
  edge[constraint=true]; 
  Invisible -> b0[style=invis]; 
  edge[constraint=true]; 
  c0 -> a0;
  Invisible -> a0[style=invis]; 
} 
') %>% 
  DiagrammeRsvg::export_svg() %>% 
  charToRaw() %>% 
  rsvg::rsvg_png("res/leafdown_workflow.png")

```

```{r, echo=FALSE, out.width=700, out.height=200}
knitr::include_graphics("../man/figures/leafdown_workflow.png")
```

(Please note that the execution of the code snippets in this chapter
**only** works within a shiny app)

### Initialization

As usual for R6 classes, we create a new object of our `Leafdown` class using the
`new()` method. \
For this we have to specify the:

- `spdfs_list`: The list containing the spdfs of both map levels.
- `map_output_id`: The output_id we specify in our ui via `leafletOutput("<<map_output_id>>")`
- `input`: The `input` from the shiny app
- `join_map_levels_by` (optional). A named vector with the columns by which the map levels 
should be joined. In case of two map levels this is set by default to c("GID_1" = "GID_1"), which is 
appropriate when 'Provinces/States' is the first and 'Districts' the second map level.
If you use 'Countries' as first  and 'Provinces/States' as second level you have to set 
it to `c("ISO" = "GID_0")`. For more information, see the Section *Joining map levels* in the [Multilevel article.](https://hoga-it.github.io/leafdown/articles/Multilevel.html)

```{r, echo=FALSE}
input <- reactiveValues(foo = "bar") # a little helper as we are currently not in a shiny session
```

```{r}
my_leafdown <- Leafdown$new(spdfs_list, map_output_id = "leafdown", input = input)
```


### Data

In the next step, we add data to our `leafdown` object.
Using the attribute `$curr_data` we can retrieve the data of the 
current map level.
At the beginning `$curr_data` only contains metadata.
With metadata, we refer to the data that describes the polygons, such as region names, 
region IDs, etc.
The metadata is automatically set with the `spdf_list[[i]]@data` where `i` is the current
map level.

```{r}
metadata <- my_leafdown$curr_data
print(head(metadata))
```

Now we can add new columns for variables we want to display on our map to the existing metadata.
It is important that the initial metadata remains unchanged and no rows are removed.

```{r}
new_data <- metadata %>% dplyr::left_join(gdp_2014_federal_states, by = c("NAME_1" = "Federal_State"))
```

After creating our new data set, we give it to our `leafdown`object with the `$add_data` method.
```{r}
my_leafdown$add_data(new_data)
```

The current data of a `leafdown` object can be retrieved via the `$curr_data` attribute.
```{r}
print(head(my_leafdown$curr_data))
```

### Draw map

To draw the map we use the method `$draw_leafdown`.
The specified arguments in the method are internally handed over to the
`addPolygons` function of `leaflet`. Therefore attributes like `fillColor` or 
`opacity` can be specified just as for a usual `leaflet` map.

```{r, eval=FALSE}
map <- my_leafdown$draw_leafdown(
  fillColor = ~ colorNumeric("Greens", GDP_2014)(GDP_2014)
) 
```


The `$draw_leafdown` method returns a usual `leaflet` map. 
This also allows us to add a legend or a background to our map.

```{r, eval=FALSE}
map <- map %>%
  addLegend(
    pal = colorNumeric("Grees", data$GDP_2014),
    values = data$GDP_2014
  )
```

### Selection

Let's now have look at what happens when a user clicks on a region.
Internally a `leafdown` object has an observer for `shape_click` events.
Once a user clicks on a certain region, this region becomes "active" and
its boundaries on the map are highlighted.
(If the clicked region is already active, it becomes inactive).
We can retrieve the data of active regions via the `$curr_sel_data` attribute.
Assuming that the user clicked on Bavaria and Hesse than `$curr_sel_data` would 
look as follows:

```{r, eval=FALSE}
my_leafdown$curr_sel_data()
```

```{r, echo=FALSE}
subset(my_leafdown$curr_data, NAME_1 %in% c("Bayern", "Hessen"))
```

Note that this attribute is a `reactiveValue` that allows to update graphs and other 
elements upon a user click. For more on the connection to other elements please
see the following 
[tutorial](https://hoga-it.github.io/leafdown/articles/Connection_to_other_elements.html).

### Drilldown

Using the `$drill_down` method we can now drill down to the admin districts of
the **active** federal states. 

```{r, eval=FALSE}
my_leafdown$drill_down()
```

This will update the currently active spdf (`my_leafdown$curr_spdf`) which then
only contains polygons and corresponding metadata for regions
whose parents were active in the upper (previous) map level.
In our case the parents are "Bavaria" and "Hesse", so only
spdfs of admin districts within these federal states will be contained in 
`my_leafdown$curr_spdf`.

```{r, eval=FALSE}
length(my_leafdown$curr_spdf)
```
```{r, echo=FALSE}
print(2)
```


### Data

The updated data can then again be retrieved via `$curr_data`.

```{r eval = FALSE}
my_leafdown$drill_down()
metadata <- my_leafdown$curr_data
head(metadata)
```

```{r echo=FALSE}
head(subset(ger2@data, GID_1 %in% c("DEU.2_1", "DEU.7_1")))
```

```{r eval = FALSE}
unique(metadata$NAME_1)
```

```{r echo=FALSE}
c("Bayern", "Hessen")
```

Just as before we can add new columns for variables we want to display on our map 
to the existing metadata.

```{r, eval=FALSE}
new_data <- metadata %>% 
  dplyr::left_join(gdp_2014_admin_districts, by = c("NAME_2" = "Admin_District"))
my_leafdown$add_data(new_data)
```

Again, the current data can be retrieved via the `$curr_data` attribute.

```{r, eval=FALSE}
head(my_leafdown$curr_data)
```

```{r, echo=FALSE}
ger2@data %>% 
  filter(GID_1 %in% c("DEU.2_1", "DEU.7_1")) %>% 
  dplyr::left_join(gdp_2014_admin_districts, by = c("NAME_2" = "Admin_District")) %>% 
  slice_head(n = 5) %>% 
  as.data.frame()
```


### Draw map

After adding `GDP_2014` to our admin district data, we can again draw our map.
Note that all non-active parent regions grayed out in the background.

```{r, eval=FALSE}
my_leafdown$draw_leafdown(
  fillColor = ~ colorNumeric("Blues", GDP_2014)(GDP_2014)
)
```


### Drillup


Using the `$drill_up` method we can now drill back up to the federal states. 
Note that the active regions (we selected before we drilled down) are still active.

```{r, eval=FALSE}
my_leafdown$drill_down()
```

### Data

To draw the map we first have to add our federal states data again.

```{r}
new_data <- metadata %>% left_join(gdp_2014_federal_states, by = c("NAME_1" = "Federal_State"))
```


### Draw map

And again we can draw our map just as usual.
```{r, eval=FALSE}
map <- my_leafdown$draw_leafdown(
  fillColor = ~ colorNumeric("Blues", GDP_2014)(GDP_2014)
) 
```

We can use the `keep_zoom()` method to keep the current zoom level as well as the current view center of the 
user after the map is drawn.

```{r, eval=FALSE}
map <- my_leafdown$keep_zoom(map, input)
```


## Shiny App

### Preparation

```{r, eval=FALSE}
library(leafdown)
library(leaflet)
library(shiny)
library(dplyr)
library(shinyjs)
ger1 <- raster::getData(country = "Germany", level = 1)
ger2 <- raster::getData(country = "Germany", level = 2)
ger2@data[c(76, 99, 136, 226), "NAME_2"] <- c(
  "Fürth (Kreisfreie Stadt)",
  "München (Kreisfreie Stadt)",
  "Osnabrück (Kreisfreie Stadt)",
  "Würzburg (Kreisfreie Stadt)"
)
spdfs_list <- list(ger1, ger2)
```

### UI
```{r, eval=FALSE}
ui <- shiny::fluidPage(
  tags$style(HTML(".leaflet-container {background: #ffffff;}")),
  useShinyjs(),
  actionButton("drill_down", "Drill Down"),
  actionButton("drill_up", "Drill Up"),
  leafletOutput("leafdown", height = 600),
)
```

### Server

```{r}
# Little helper function for hover labels
create_labels <- function(data, map_level) {
  labels <- sprintf(
    "<strong>%s</strong><br/>%g € per capita</sup>",
    data[, paste0("NAME_", map_level)], data$GDP_2014
  )
  labels %>% lapply(htmltools::HTML)
}
```


```{r, eval=FALSE}
server <- function(input, output) {
  my_leafdown <- Leafdown$new(spdfs_list, "leafdown", input)
  update_leafdown <- reactiveVal(0)

  observeEvent(input$drill_down, {
    my_leafdown$drill_down()
    update_leafdown(update_leafdown() + 1)
  })

  observeEvent(input$drill_up, {
    my_leafdown$drill_up()
    update_leafdown(update_leafdown() + 1)
  })

  output$leafdown <- renderLeaflet({
    update_leafdown()
    meta_data <- my_leafdown$curr_data
    curr_map_level <- my_leafdown$curr_map_level
    if (curr_map_level == 1) {
      data <- meta_data %>% left_join(gdp_2014_federal_states, by = c("NAME_1" = "Federal_State"))
    } else {
      data <- meta_data %>% left_join(gdp_2014_admin_districts, by = c("NAME_2" = "Admin_District"))
    }

    my_leafdown$add_data(data)
    labels <- create_labels(data, curr_map_level)
    my_leafdown$draw_leafdown(
      fillColor = ~ colorNumeric("Greens", GDP_2014)(GDP_2014),
      weight = 2, fillOpacity = 0.8, color = "grey", label = labels,
      highlight = highlightOptions(weight = 5, color = "#666", fillOpacity = 0.7)
    ) %>% 
      my_leafdown$keep_zoom(input) %>% 
      addLegend("topright",
        pal = colorNumeric("Blues", data$GDP_2014),
        values = data$GDP_2014,
        title = "GDP per capita (2014)",
        labFormat = labelFormat(suffix = "€"),
        opacity = 1
      )
  })
}
```

### Run App
```{r, eval=FALSE}
shinyApp(ui, server)
```

<style>
.shiny-app-frame {
  position: relative;
  height: 700px;
}
.shiny-app-frame iframe {
  width: 100%;
  height: 100%;
  border: none;
}
</style>

<br>
<div class="shiny-app-frame"> 
<iframe src="https://andreasho95.shinyapps.io/leafdown-basic-example/">
</iframe>
</div>

---
title: "Connection to other Shiny elements"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Connection to other Shiny elements}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```
In this article, we demonstrate how to connect a `leafdown` map to other Shiny elements. <br>

```{r, echo=FALSE, out.width="100%"}
knitr::include_graphics("../man/figures/app_election_map.png")
```
Click here for the [full demo app](https://pega.shinyapps.io/election16/)

## Data
As described in the [Introduction article.](https://hoga-it.github.io/leafdown/articles/Introduction.html), we need two 
types of data:

- **SpatialPolygonsDataFrames**, the shapes of the US-States and Counties, taken from the `raster` package.

- **Election Results and Census Data**, the data we want to display on the map, taken from the example data sets that 
  come with the `leafdown` package. (The original data comes from [Deleetdk](https://github.com/Deleetdk/USA.county.data). 
  For more information about the data, please see `?us_election_states` or `?us_election_counties` respectively)

## The Map itself
The structure of the map is pretty similar to the map from the [Introduction article.](https://hoga-it.github.io/leafdown/articles/Introduction.html)
Here we show the results of the US Presidential Election from 2016.

## Connecting Graphs to our Map
In this section, we want to demonstrate how simple it is to connect graphs or similar UI-elements with the map.

We create two graphs that give more insight into the currently selected shapes: </br>

- As the map only shows the winner, we create a bar chart to show the percentages from every party.
- Additionally, we add a graph showing the racial makeup.

The changes in the UI are straightforward:
```{r, eval = FALSE}
column(
  width = 5,
  # box for racial makeup graph
  bs4Card(
    width = 12,
    closable = F,
    collapsible = F,
    title = "Racial makeup in percentages",
    echarts4rOutput("socio")
  ),
  # box for party percent graph
  bs4Card(
    width = 12,
    closable = F,
    collapsible = F,
    title = "Votes in percent",
    echarts4rOutput("party")
  )
)
```

To connect the graphs with the map, we can use the `$curr_sel_data()` attribute.
This attribute is a `reactiveValue` which allows us to update the graphs whenever the user selects a shape on the map or drills a level up or down.

In the server, we obtain the data using `df <- my_leafdown$curr_sel_data()`. 

Creating the rest of the graph is again straightforward.

```{r, eval = FALSE}
output$party <- renderEcharts4r({
  # get the currently selected data from the map
  df <- my_leafdown$curr_sel_data()

  # check whether any shape is selected, show general election-result if nothing is selected
  if (nrow(df) > 0) {
    if (my_leafdown$curr_map_level == 1) {
      df <- df[, c("state_abbr", "Democrats2016", "Republicans2016", "Libertarians2016", "Green2016")]
      df <- df %>%
        pivot_longer(2:5, "party") %>%
        group_by(party)
    } else {
      df <- df[, c("County", "Democrats2016", "Republicans2016", "Libertarians2016", "Green2016")]
      df <- df %>%
        pivot_longer(2:5, "party") %>%
        group_by(party)
      df$value <- df$value
      names(df)[1] <- "state_abbr"
    }
  } else {
    # show general election-result as no state is selected
    df <- data.frame(
      party = c("Democrats2016", "Republicans2016", "Libertarians2016", "Green2016"),
      state_abbr = "USA",
      value = c(0.153, 0.634, 0.134, 0.059)
    ) %>%
      group_by(party)
  }
  # create the graph
  df %>%
    e_charts(state_abbr, stack = "grp") %>%
    e_bar(value) %>%
    e_y_axis(formatter = e_axis_formatter("percent", digits = 2)) %>%
    e_tooltip(trigger = "axis", axisPointer = list(type = "shadow")) %>%
    e_legend(right = 10, top = 10) %>%
    e_color(c("#232066", "#E91D0E", "#f3b300", "#006900")) %>%
    e_tooltip(formatter = e_tooltip_item_formatter("percent", digits = 2))
})
```

# Final Demo App
<details>
<summary>The full code of the election map...</summary>
**Note:** The shapes have to be manually downloaded before the app can be used.</br>
In the given election app the shapes have also been simplified to 0.5% of their original size. 
```{r, eval=FALSE}
states <- raster::getData(country = "USA", level = 1)
counties <- raster::getData(country = "USA", level = 2)
# TODO replace the path to your downloaded shapes in the server code
```

```{r, eval=FALSE}
library(shiny)
library(bs4Dash)
library(shinyjs)
library(leaflet)
library(leafdown)
library(echarts4r)
library(dplyr)
library(tidyr)
library(RColorBrewer)

ui <- bs4DashPage(
  title = "Leafdown Showcase - USA Election Data",
  navbar = bs4DashNavbar(tags$h3("Leafdown Showcase - USA Election Data", style = "margin-bottom: .2rem;")),
  bs4DashSidebar(disable = TRUE),
  body = bs4DashBody(
    # set the background of the map-container to be white
    tags$head(
      tags$style(HTML(".leaflet-container { background: #fff; height: 100%}")),
      # workaround for the NA in leaflet legend see https://github.com/rstudio/leaflet/issues/615
      tags$style(HTML(".leaflet-control div:last-child {clear: both;}")),
      tags$style(HTML(".card {height: 100%;}")),
      tags$style(HTML(".col-sm-12:last-child .card {margin-bottom: 0 !important;}")),
      tags$style(HTML("#leafdown {height: 80% !important; margin-top: 10px; margin-bottom: 10px;}"))
    ),
    # we need shinyjs for the leafdown map
    useShinyjs(),
    fluidRow(
      # a card for the map
      bs4Card(
        title = "Map",
        closable = FALSE,
        collapsible = FALSE,
        width = 6,
        # a dropdown to select what KPI should be displayed on the map
        selectInput(
          "map_sel", "Select what KPI to display on the map:",
          c("Votes" = "votes", "Unemployment" = "unemployment")
        ),
        # the two buttons used for drilling
        actionButton("drill_down", "Drill Down"),
        actionButton("drill_up", "Drill Up"),
        # the actual map element
        leafletOutput("leafdown")
      ),

      # a column with the two graphs
      column(
        width = 6,
        # box for racial makeup graph
        bs4Card(
          width = 12,
          closable = F,
          collapsible = F,
          title = "Racial makeup in percentages",
          echarts4rOutput("socio")
        ),
        # box for party percent graph
        bs4Card(
          width = 12,
          closable = F,
          collapsible = F,
          title = "Votes in percent",
          echarts4rOutput("party")
        )
      )
    )
  )
)

# Create user-defined function
percent <- function(x, digits = 2, format = "f", ...) { 
  paste0(formatC(x * 100, format = format, digits = digits, ...), "%")
}

create_labels <- function(data, map_level) {
  labels <- sprintf(
    "<strong>%s</strong><br/>
    Democrats: %s<br/>
    Republicans: %s<br/>
    Libertarians: %s<br/>
    Green: %s<br/>
    </sup>",
    data[, paste0("NAME_", map_level)],
    percent(data$Democrats2016),
    percent(data$Republicans2016),
    percent(data$Libertarians2016),
    percent(data$Green2016)
  )
  labels %>% lapply(htmltools::HTML)
}

# Define server for leafdown app
server <- function(input, output) {
  # load the shapes for the two levels
  # TODO load the shapes you have downloaded via the raster package
  states <- readRDS("../inst/app_election/us1.RDS")
  counties <- readRDS("../inst/app_election/us2.RDS")
  spdfs_list <- list(states, counties)

  # create leafdown object
  my_leafdown <- Leafdown$new(spdfs_list, "leafdown", input)

  rv <- reactiveValues()
  rv$update_leafdown <- 0

  # observers for the drilling buttons
  observeEvent(input$drill_down, {
    my_leafdown$drill_down()
    rv$update_leafdown <- rv$update_leafdown + 1
  })

  observeEvent(input$drill_up, {
    my_leafdown$drill_up()
    rv$update_leafdown <- rv$update_leafdown + 1
  })

  data <- reactive({
    req(rv$update_leafdown)
    # fetch the current metadata from the leafdown object
    data <- my_leafdown$curr_data

    # join the metadata with the election-data.
    # depending on the map_level we have different election-data so the 'by' columns for the join are different
    if (my_leafdown$curr_map_level == 2) {
      data$ST <- substr(data$HASC_2, 4, 5)
      # there are counties with the same name in different states so we have to join on both
      data <- left_join(data, us_election_counties, by = c("NAME_2", "ST"))
    } else {
      data$ST <- substr(data$HASC_1, 4, 5)
      data <- left_join(data, us_election_states, by = "ST")
    }
    # add the data back to the leafdown object
    my_leafdown$add_data(data)
    data
  })

  # this is where the leafdown magic happens
  output$leafdown <- renderLeaflet({
    req(spdfs_list)
    req(data)

    data <- data()

    # depending on the selected KPI in the dropdown we show different data
    if (input$map_sel == "unemployment") {
      data$y <- data$Unemployment * 100
      fillcolor <- leaflet::colorNumeric("Greens", data$y)
      legend_title <- "Unemployment in Percent"
    } else {
      data$y <- ifelse(data$Republicans2016 > data$Democrats2016, "Republicans", "Democrats")
      fillcolor <- leaflet::colorFactor(c("#232066", "#E91D0E"), data$y)
      legend_title <- "Winning Party"
    }

    labels <- create_labels(data, my_leafdown$curr_map_level)
    # draw the leafdown object
    my_leafdown$draw_leafdown(
      fillColor = ~ fillcolor(data$y),
      weight = 3, fillOpacity = 1, color = "white", label = labels
    ) %>%
      # set the view to be center on the USA
      setView(-95, 39, 4) %>%
      # add a nice legend
      addLegend(
        pal = fillcolor,
        values = ~ data$y,
        title = legend_title,
        opacity = 1
      )
  })

  # plots
  output$socio <- renderEcharts4r({
    df <- my_leafdown$curr_sel_data()
    # check whether any shape is selected, show basic info for the whole usa if nothing is selected
    if (nrow(df) > 0) {
      if (my_leafdown$curr_map_level == 1) {
        df <- df[, c("State", "Hispanic", "White", "Black", "Asian", "Amerindian", "Other")]
        df <- df %>%
          pivot_longer(2:7, "race") %>%
          group_by(State)
        df$value <- round(df$value, 2)
      } else {
        df <- df[, c("County", "Hispanic", "White", "Black", "Asian", "Amerindian", "Other")]
        df <- df %>%
          pivot_longer(2:7, "race") %>%
          group_by(County)
        df$value <- round(df$value / 100, 2)
      }
    } else {
      # show basic info for the whole usa as no state is selected
      df <- data.frame(
        ST = "USA",
        race = c("Hispanic", "White", "Black", "Asian", "Amerindian", "Other"),
        value = c(0.15, 0.634, 0.134, 0.059, 0.015, 0.027)
      ) %>%
        group_by(ST)
    }
    # create the graph
    df %>%
      e_charts(race) %>%
      e_bar(value) %>%
      e_tooltip(trigger = "axis", axisPointer = list(type = "shadow")) %>%
      e_y_axis(
        splitArea = list(show = FALSE),
        splitLine = list(show = FALSE),
        formatter = e_axis_formatter("percent", digits = 2)
      ) %>%
      e_legend(orient = "vertical", right = 10, top = 10) %>%
      e_color(brewer.pal(nrow(df), "Set3")) %>%
      e_tooltip(formatter = e_tooltip_item_formatter("percent"))
  })

  output$party <- renderEcharts4r({
    df <- my_leafdown$curr_sel_data()
    # check whether any shape is selected, show general election-result if nothing is selected
    if (nrow(df) > 0) {
      if (my_leafdown$curr_map_level == 1) {
        df <- df[, c("ST", "Democrats2016", "Republicans2016", "Libertarians2016", "Green2016")]
        df <- df %>%
          pivot_longer(2:5, "party") %>%
          group_by(party)
      } else {
        df <- df[, c("County", "Democrats2016", "Republicans2016", "Libertarians2016", "Green2016")]
        df <- df %>%
          pivot_longer(2:5, "party") %>%
          group_by(party)
        df$value <- df$value
        names(df)[1] <- "ST"
      }
    } else {
      # show general election-result as no state is selected
      df <- data.frame(
        party = c("Democrats2016", "Republicans2016", "Libertarians2016", "Green2016"),
        ST = "USA",
        value = c(0.153, 0.634, 0.134, 0.059)
      ) %>%
        group_by(party)
    }
    # create the graph
    df %>%
      e_charts(ST, stack = "grp") %>%
      e_bar(value) %>%
      e_y_axis(formatter = e_axis_formatter("percent", digits = 2)) %>%
      e_tooltip(trigger = "axis", axisPointer = list(type = "shadow")) %>%
      e_legend(right = 10, top = 10) %>%
      e_color(c("#232066", "#E91D0E", "#f3b300", "#006900")) %>%
      e_tooltip(formatter = e_tooltip_item_formatter("percent", digits = 2))
  })
}

shinyApp(ui, server)

```
</details>

You can find the [full demo app](https://pega.shinyapps.io/election16/) hosted on shinyapps.io

---
title: "More than two map levels"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{More than two map levels}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```


In this article, we demonstrate how to set up a `leafdown` map with three map levels and show that it is an natural
extension of the two map level case. (More than two map levels is supported from `leafdown` version 1.1.)

```{r, echo=FALSE, out.width="70%"}
knitr::include_graphics("../man/figures/app_dach_map.png")
```

Let's first load the libraries we are going to use for our app. \

```{r setup, message=FALSE,warning=FALSE}
library(leafdown)
library(leaflet)
library(shiny)
library(dplyr)
library(shinycssloaders)
library(shinyjs)
library(dplyr)
library(raster)
```

(Note that the `shinyjs` package is loaded for some automatic warning messages that the 
`leafdown` map can return to the user of the shiny app.)


## SpatialPolygonsDataFrames

As usual, we first create a list of `SpatialPolygonsDataFrames` (`spdfs`) for the regions we want to display on our map.
(Further details can be found in the [Introduction article](https://hoga-it.github.io/leafdown/articles/Introduction.html).)

```
list (spdfs_list)
│   
└───spdf (spdf of first map level)
│
└───spdf (spdf of second map level)
│
└───spdf (spdf of third map level)
```

```{r, echo=FALSE}
ger0 <- readRDS("../inst/extdata/ger0-005.RDS")
ger1 <- readRDS("../inst/extdata/ger1-005.RDS")
ger2 <- readRDS("../inst/extdata/ger2-005.RDS")
aut0 <- readRDS("../inst/extdata/a0-005.RDS")
aut1 <- readRDS("../inst/extdata/a1-005.RDS")
aut2 <- readRDS("../inst/extdata/a2-005.RDS")
ch0 <- readRDS("../inst/extdata/ch0-005.RDS")
ch1 <- readRDS("../inst/extdata/ch1-005.RDS")
ch2 <- readRDS("../inst/extdata/ch2-005.RDS")
```

```{r, eval=FALSE}
# Germany
ger0 <- raster::getData(country = "Germany", level = 0)
ger1 <- raster::getData(country = "Germany", level = 1)
ger2 <- raster::getData(country = "Germany", level = 2)
# Austria
a0 <- raster::getData(country = "Austria", level = 0)
a1 <- raster::getData(country = "Austria", level = 1)
a2 <- raster::getData(country = "Austria", level = 2)
# Switzerland
ch0 <- raster::getData(country = "Switzerland", level = 0)
ch1 <- raster::getData(country = "Switzerland", level = 1)
ch2 <- raster::getData(country = "Switzerland", level = 2)
```

```{r, message=FALSE}
spdfs_list <- list(rbind(aut0, ch0, ger0), rbind(aut1, ch1, ger1), rbind(aut2, ch2, ger2))
```


## Data

For this app, we simply generate random target values `y`.

```{r, message=FALSE}
set.seed(20220106)
# Simulate data
data_sim_y_level_3 <- spdfs_list[[3]]@data
data_sim_y_level_3$y <- round(rnorm(nrow(data_sim_y_level_3), 1e2, sd = 5e2), 0)
data_sim_y_level_2 <- data_sim_y_level_3 %>% group_by(NAME_0, NAME_1) %>% summarise(y = sum(y))
data_sim_y_level_1 <- data_sim_y_level_2 %>% group_by(NAME_0) %>% summarise(y = sum(y))

# Assign map levels
data_sim_y_level_3$level <- 3
data_sim_y_level_2$level <- 2
data_sim_y_level_1$level <- 1

# Assign area names
data_sim_y_level_3$area <- data_sim_y_level_3$NAME_2
data_sim_y_level_2$area <- data_sim_y_level_2$NAME_1
data_sim_y_level_1$area <- data_sim_y_level_1$NAME_0

# Combine data of map levels
data_sim_y <- rbind(
  data_sim_y_level_3[, c("area", "y", "level")],
  data_sim_y_level_2[, c("area", "y", "level")],
  data_sim_y_level_1[, c("area", "y", "level")]
)

head(data_sim_y)
```

## Joining map levels

In order for a `leafdown` map to know which shapes of a lower map level belong to the shapes in the upper map level, we
need to specify how the data of the `spdfs` of different map levels need to be joined. \newline
This is defined by the `join_map_levels_by` argument, which is a named vector of length `length(spdfs_list) - 1`, whereby

- the first (named) element specifies how to join the first and the second map level
- the second (named) element specifies how to join the second and the third map level
- and so on.

The name of an element specifies the join column in the respective upper map level and the actual element the join column 
of the lower map level.

Let's have a look at the data of our the `spdfs` in `spdf_list`:

```{r}
head(spdfs_list[[1]]@data)
```

```{r}
head(spdfs_list[[2]]@data[, c("GID_0", "NAME_0", "GID_1", "NAME_1")])
```

In this example, map levels 1 and 2 can be joined by their column "GID_0". So the name of first element is "GID_0" 
(the respective column name of the first map level) and the first element is also "GID_0" (the respective column name of 
the first map level):

```{r}
head(spdfs_list[[3]]@data[, c("GID_0", "NAME_0", "GID_1", "NAME_1", "GID_2", "NAME_2")])
```

We see, that map levels 2 and 3 can be joined by their column "GID_1".

This translates into the following `join_map_levels_by` argument:

```{r, eval=FALSE}
my_leafdown <- Leafdown$new(
  spdfs_list, "leafdown", input, join_map_levels_by = c("GID_0" = "GID_0", "GID_1" = "GID_1")
)
```



## Shiny App

### Preparation

```{r, eval=FALSE}
library(leafdown)
library(leaflet)
library(shiny)
library(dplyr)
library(shinycssloaders)
library(shinyjs)
library(dplyr)
library(raster)

# Germany
ger0 <- raster::getData(country = "Germany", level = 0)
ger1 <- raster::getData(country = "Germany", level = 1)
ger2 <- raster::getData(country = "Germany", level = 2)
# Austria
a0 <- raster::getData(country = "Austria", level = 0)
a1 <- raster::getData(country = "Austria", level = 1)
a2 <- raster::getData(country = "Austria", level = 2)
# Switzerland
ch0 <- raster::getData(country = "Switzerland", level = 0)
ch1 <- raster::getData(country = "Switzerland", level = 1)
ch2 <- raster::getData(country = "Switzerland", level = 2)

# load the shapes for the three levels
spdfs_list <- list(rbind(aut0, ch0, ger0), rbind(aut1, ch1, ger1), rbind(aut2, ch2, ger2))

# Simulate some data
set.seed(20220106)
data_sim_y_level_3 <- spdfs_list[[3]]@data
data_sim_y_level_3$y <- rnorm(nrow(data_sim_y_level_3), 1e2, sd = 5e2)
data_sim_y_level_2 <- data_sim_y_level_3 %>% group_by(NAME_0, NAME_1) %>% summarise(y = sum(y))
data_sim_y_level_1 <- data_sim_y_level_2 %>% group_by(NAME_0) %>% summarise(y = sum(y))

data_sim_y_level_3$level <- 3
data_sim_y_level_2$level <- 2
data_sim_y_level_1$level <- 1

data_sim_y_level_3$area <- data_sim_y_level_3$NAME_2
data_sim_y_level_2$area <- data_sim_y_level_2$NAME_1
data_sim_y_level_1$area <- data_sim_y_level_1$NAME_0

data_sim_y <- rbind(
  data_sim_y_level_3[, c("area", "y", "level")],
  data_sim_y_level_2[, c("area", "y", "level")],
  data_sim_y_level_1[, c("area", "y", "level")]
)
data_sim_y$y <- round(data_sim_y$y, 0)
```

### UI
```{r, eval=FALSE}
ui <- fluidPage(
  mainPanel(
    # set the background of the map-container to be white
    tags$head(
      tags$style(HTML(".leaflet-container { background: #fff; height: 100%}")),
      # workaround for the NA in leaflet legend see https://github.com/rstudio/leaflet/issues/615
      tags$style(HTML(".leaflet-control div:last-child {clear: both;}"))
    ),
    # we need shinyjs for the leafdown map
    useShinyjs(),
    fluidRow(
      # the two buttons used for drilling
      actionButton("drill_down", "Drill Down"),
      actionButton("drill_up", "Drill Up"),
      # the actual map element
      withSpinner(leafletOutput("leafdown", height = 800), type = 8)
    )
  )
)

```

### Server

```{r}
# Little helper function for hover labels
create_labels <- function(data, map_level) {
  labels <- sprintf(
    "<strong>%s</strong><br/>%g</sup>",
    data[, paste0("NAME_", map_level - 1)], data$y
  )
  labels %>% lapply(htmltools::HTML)
}
```


```{r, eval=FALSE}
server <- function(input, output) {

  # create leafdown object
  my_leafdown <- Leafdown$new(
    spdfs_list, "leafdown", input, join_map_levels_by = c("GID_0" = "GID_0", "GID_1" = "GID_1")
  )

  rv <- reactiveValues()
  rv$update_leafdown <- 0

  # observers for the drilling buttons
  observeEvent(input$drill_down, {
    my_leafdown$drill_down()
    rv$update_leafdown <- rv$update_leafdown + 1
  })

  observeEvent(input$drill_up, {
    my_leafdown$drill_up()
    rv$update_leafdown <- rv$update_leafdown + 1
  })

  data <- reactive({
    req(rv$update_leafdown)
    meta_data <- my_leafdown$curr_data
    curr_map_level <- my_leafdown$curr_map_level
    data_curr_map_level <- data_sim_y[data_sim_y$level == curr_map_level, ]
    join_col_lhs <- paste0("NAME_", curr_map_level - 1)
    data <- meta_data %>% left_join(data_curr_map_level, by = setNames("area", join_col_lhs))

    # add the data back to the leafdown object
    my_leafdown$add_data(data)
    data
  })

  # this is where the leafdown magic happens
  output$leafdown <- renderLeaflet({
    req(spdfs_list)
    req(data)

    data <- data()
    labels <- create_labels(data, my_leafdown$curr_map_level)
    # draw the leafdown object
    my_leafdown$draw_leafdown(
      fillColor = ~leaflet::colorNumeric("Greens", data$y)(data$y),
      weight = 3, fillOpacity = 1, color = "grey", label = labels
    )
  })
}
```

### Run App
```{r, eval=FALSE}
shinyApp(ui, server)
```

<style>
.shiny-app-frame {
  position: relative;
  height: 1100px;
}
.shiny-app-frame iframe {
  width: 100%;
  height: 100%;
  border: none;
}
</style>

<br>
<div class="shiny-app-frame"> 
<iframe src="https://andreasho95.shinyapps.io/leafdown-multi-level/">
</iframe>
</div>
